package com.ef_prime.rflow;

import java.awt.BorderLayout;
import java.awt.GraphicsEnvironment;
import java.io.File;

import javax.swing.JFrame;

import com.ef_prime.rflow.resource.Messages;

public class MainFrame extends JFrame{
	
	private static final String TITLE = "R AnalyticFlow"; //$NON-NLS-1$
	private static final String SPACE = "  -  "; //$NON-NLS-1$
	private static final String DIRTYFLAG = "*"; //$NON-NLS-1$
	
	public MainFrame(){
		super(TITLE);
		setDefaultCloseOperation(MainFrame.DO_NOTHING_ON_CLOSE);

		setIconImage(FileResource.DESKTOP_16.getImage());
		
		setSize(800, 600);
		int centerY = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y;
		setLocation(600-200, centerY-300);
		setLayout(new BorderLayout());
	}
	
	/**
	 * 
	 * @param file  if null, clear file name.
	 */
	public void setFileName(File file, boolean isDirty) {
		if(file == null){
			if(isDirty)
				setTitle(TITLE+SPACE+DIRTYFLAG+Messages.getString("MainFrame.new_flow")); //$NON-NLS-1$
			else
				setTitle(TITLE);
		}else{
			if(isDirty)
				setTitle(TITLE+SPACE+DIRTYFLAG+file.getName());
			else
				setTitle(TITLE+SPACE+file.getName());
		}
	}
}
