package com.ef_prime.rflow;

import java.awt.Component;
import java.io.File;

import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.node.NodeModel;
import com.ef_prime.rflow.resource.Messages;
import com.ef_prime.rflow.tool.RflowFileFilterFactory;
import com.ef_prime.rflow.util.FileChooserUtility;

public class RflowUtil {
	
	/**
	 * choose source file and parse to ViewLayout.
	 * @param parent dialog parent
	 * @return ViewLayout of parsed source file. null if canceled or failed
	 */
	public static ViewLayout importSource(Component parent){

		FileFilter[] filters = new FileFilter[]{RflowFileFilterFactory.createRFileFilter()};
		File file = FileChooserUtility.chooseOpenFile(Messages.getString("Message.open"), Prefs.WORKING_DIRECTORY, filters, parent); //$NON-NLS-1$
		if(file == null)
			return null;
		
		NodeModel[] models = RCommand.parseToNodes(file, true);
		if(models == null){
			JOptionPane.showMessageDialog(parent, Messages.getString("Error.read"), Messages.getString("Error.title.error"), JOptionPane.ERROR_MESSAGE); //$NON-NLS-1$ //$NON-NLS-2$
			return null;
		}

		return new ViewLayout(models);
	}
}
