package com.ef_prime.rflow.flow;

import javax.swing.event.UndoableEditEvent;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoManager;

class FlowUndoManager extends UndoManager{
	
	private FlowViewer viewer;
	private boolean working;
	
	FlowUndoManager(FlowViewer viewer){
		this.viewer = viewer;
	}
	
	@Override
	public synchronized void undo() throws CannotUndoException {
		working = true;
		try{
			super.undo();
		}finally{
			working = false;
		}
	}
	
	@Override
	public synchronized void redo() throws CannotRedoException {
		working = true;
		try{
			super.redo();
		}finally{
			working = false;
		}
	}
	
	
	@Override
	public void undoableEditHappened(UndoableEditEvent e) {
		if(working)return;
		super.undoableEditHappened(e);
		viewer.updateUndoState();
	}
}
