package com.ef_prime.rflow.flow.model;

import java.util.ArrayList;
import java.util.List;

import com.ef_prime.rflow.node.NodeModel;
import com.ef_prime.rflow.node.NodeModelChangeListener;

import edu.uci.ics.jung.graph.impl.DirectedSparseVertex;

public class FlowNode extends DirectedSparseVertex{
	private NodeModel model;
	//private NodeModel unmodifiable;
	
	public FlowNode(NodeModel model){
		super();
		this.model = model;
		//unmodifiable = new UnmodifiableNodeModel(model);
	}

	public NodeModel getModel() {
		//return unmodifiable;
		return model;
	}

	public void setModel(NodeModel model) {
		if(getModel().equals(model))
			return;
		NodeModel old = this.model;
		this.model = model;
		//unmodifiable = new UnmodifiableNodeModel(model);
		fireNodeModelChanged(this, old, model);
	}
	
	public FlowNode newInstance(){
		return new FlowNode(model.copy());
	}

	private static List<NodeModelChangeListener> listeners = new ArrayList<NodeModelChangeListener>();
	
	public static void addNodeModelChangeListener(NodeModelChangeListener listener){
		listeners.add(listener);
	}
	
	private static void fireNodeModelChanged(FlowNode node, NodeModel old, NodeModel model){
		for(NodeModelChangeListener l : listeners){
			l.nodeModelChanged(node, old, model);
		}
	}
}
