package com.ef_prime.rflow.node.base;

import java.util.Properties;

import com.ef_prime.rflow.exception.InvalidOptionException;
import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.io.FlowDataElements;
import com.ef_prime.rflow.node.DefaultNodeModelController;
import com.ef_prime.rflow.node.NodeModel;
import com.ef_prime.rflow.node.NodeOptionPanel;

public class SubflowNodeModelController extends DefaultNodeModelController implements FlowDataElements{

	public Class<? extends NodeModel> getModelClass() {
		return SubflowNodeModel.class;
	}

	public String getModelName() {
		return "サブフロー";
	}
	
	public Properties getOptionProperties(NodeModel model) {
		return null;
	}
	
	public NodeModel createModel(Properties properties, String title, String command) throws ModelCreationFailedException {
		throw new ModelCreationFailedException();
	}
	
	@Override
	public boolean isAddable() {
		return false;
	}

	@Override
	protected NodeOptionPanel createNodeOptionPanel(NodeModel model) {
		return new SubflowNodeOptionPanel(model);
	}

	private static class SubflowNodeOptionPanel extends NodeOptionPanel{

		private NodeModel model;
		
		public SubflowNodeOptionPanel(NodeModel model) {
			super();
			this.model = model;
		}

		@Override
		protected NodeModel getModel() throws InvalidOptionException {
			return model;
		}
		
	}
	
	/*
	private static final String WIDTH = "width"; //$NON-NLS-1$
	private static final String HEIGHT = "height"; //$NON-NLS-1$
	private static final String NODE = "node"; //$NON-NLS-1$
	*/
	
	/*
	@Override
	protected Document createXMLDocument(NodeModel nodeModel0, DOMImplementation domImpl) {
		BoxNodeModel model = (BoxNodeModel)nodeModel0;
		
		
		model.update();
		ViewLayout layout = model.getLayout();
		
		Document document = domImpl.createDocument("", "box", null); //$NON-NLS-1$ //$NON-NLS-2$
		
		Element box = document.getDocumentElement();
		box.setAttribute(WIDTH, String.valueOf(layout.getSize().width));
		box.setAttribute(HEIGHT, String.valueOf(layout.getSize().height));

		//node -> id MAP
		Map<Vertex, Integer> nodeToIdMap = new HashMap<Vertex, Integer>(); 
		
		for(Object o : layout.getGraph().getVertices()){
			FlowNode node = (FlowNode)o;
			NodeModel nodeModel = node.getModel();
			

			int id = nodeToIdMap.size();
			nodeToIdMap.put(node, id);
			
			
			Element nodeElement = document.createElement(NODE);
			nodeElement.setAttribute(ID, String.valueOf(id));
			nodeElement.setAttribute(TITLE, nodeModel.getTitle());
			Point2D p = layout.getLocationMap().get(node);
			nodeElement.setAttribute(X, String.valueOf((float)p.getX()));
			nodeElement.setAttribute(Y, String.valueOf((float)p.getY()));
			box.appendChild(nodeElement);

			Element commandElement = document.createElement(COMMAND);
			commandElement.setTextContent(nodeModel.getCommand());
			nodeElement.appendChild(commandElement);
			
				

			Element optionElement = document.createElement(OPTION);
			optionElement.setAttribute(TYPE, nodeModel.getClass().getCanonicalName());
			
			NodeModelController controller = NodeModelManager.getModelController(nodeModel.getClass());
			Document d = null;
			if(controller != null)
				d = controller.getOptionProperties(nodeModel);
			if(d != null){
				TransformerFactory transFactory = TransformerFactory.newInstance();
				StringWriter stringWriter = new StringWriter();
				try {
					Transformer transformer = transFactory.newTransformer();
					transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8"); //$NON-NLS-1$
					transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes"); //$NON-NLS-1$
	
					//StreamResult result = new StreamResult(fileOut);
					
					transformer.transform(new DOMSource(d), new StreamResult(stringWriter));
				} catch (TransformerConfigurationException e) {
					// TODOAuto-generated catch block
					e.printStackTrace();
				} catch (TransformerException e) {
					// TODOAuto-generated catch block
					e.printStackTrace();
				}
				
				//CDATASection cdata = document.createCDATASection(stringWriter.getBuffer().toString());
				//optionElement.appendChild(cdata);
				optionElement.setTextContent(stringWriter.getBuffer().toString());
			}
			nodeElement.appendChild(optionElement);
		}
		
		//EDGE
		for(Object ob_e : layout.getGraph().getEdges()){
			FlowEdge e = (FlowEdge)ob_e;
			
			Element edgeElement = document.createElement(EDGE);
			edgeElement.setAttribute(FROM, nodeToIdMap.get(e.getSource()).toString());
			edgeElement.setAttribute(TO, nodeToIdMap.get(e.getDest()).toString());
			box.appendChild(edgeElement);
		}
		
		return document;
	}
	*/
	
}
